<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on January 8, 2010 at 3:05:51 pm</time-stamp>
<!-- Changes from: PV-Datachannel(Green.328,sourcecontrol)  to: PV-Datachannel(Green.329,bbuxton) -->


<class>
<name>SimpleSerializer</name>
<environment>PROVISO</environment>
<super>PROVISO.SimpleVisitor</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>stream isBigEndian classToIdMap idToClassMap mapVersions byteBuffer lastPosition </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-CME-ES</category>
<attributes>
<package>PV-Base Extensions</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>writing</category>

<body package="PV-Base Extensions" selector="writeClass:">writeClass: aClass
	
	| id |
	id := self idForClass: aClass.
	self writeVarInt: id.
	^id</body>

<body package="PV-Base Extensions" selector="writeSimpleSerializerStandIn:">writeSimpleSerializerStandIn: aStandIn

	^aStandIn writeTo: self</body>

<body package="PV-Base Extensions" selector="write:">write: anObject 
	"Write the class id, then visit the object"
	
	| id |
	id := (self class usesStandIn includes: anObject class) 
		ifTrue: [id := self idForClass: anObject class]
		ifFalse: [self writeClass: anObject class].
	self 
		visit: anObject
		class: (self classForId: id)
		task: #write</body>
</methods>

<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>reading</category>

<body package="PV-Base Extensions" selector="read">read
	
	| inst cls |
	cls := self readClass.
	inst := self instantiate: cls.
	^self 
		visit: inst
		class: cls
		task: #read</body>

<body package="PV-Base Extensions" selector="readSimpleSerializerStandIn:">readSimpleSerializerStandIn: aStandIn

	^aStandIn readFrom: self</body>

<body package="PV-Base Extensions" selector="readClass">readClass
	
	^self classForId: self readVarInt</body>
</methods>


<methods>
<class-id>PROVISO.SimpleSerializer class</class-id> <category>class maps - base</category>

<body package="PV-Base Extensions" selector="baseClassMap2">baseClassMap2
	&lt;classMap: #base version: 2&gt;
	^{
		UndefinedObject.
		Object.
		Boolean.
		String.
		ByteArray.
		Symbol.
		Association.
		ArithmeticValue.
		Integer.
		SmallInteger.
		LargePositiveInteger.
		LargeNegativeInteger.
		Float.
		Double.
		Fraction.
		Array.
		OrderedCollection.
		Set.
		Dictionary.
		SimpleSerializerStandIn
	}</body>
</methods>

<methods>
<class-id>PROVISO.SimpleSerializer class</class-id> <category>utility</category>

<body package="PV-Base Extensions" selector="usesStandIn">usesStandIn

	^##(IdentitySet with: Smee.SmeeObject with: Smee.SmeeDate with: Smee.SmeeArray)</body>
</methods>

<methods>
<class-id>PROVISO.SimpleSerializer class</class-id> <category>class maps - smee</category>

<body package="PV-Base Extensions" selector="smeeClassMap2">smeeClassMap2
	&lt;classMap: #smee version: 2&gt;
	^{
		Smee.SmeeArray.
		Smee.SmeePropertyDictionary.
		Smee.SmeeDate.
		Smee.SmeeObject.
		Smee.SmeeDefaultPropertyDictionary.
		Smee.SmeeAccessor.
		Smee.SmeeAccessorProperty.
		Smee.SmeeAbstractProperty.
		Smee.SmeeDontEnumDontDeleteProperty.
		Smee.SmeeDontDeleteProperty.
		Smee.SmeeProperty.
		Smee.SmeeReadOnlyProperty.
		Smee.SmeeReadOnlyDontDeleteProperty.
		Smee.SmeeDontEnumProperty.
		Smee.SmeeReadOnlyDontEnumProperty.
		Smee.SmeeReadOnlyDontEnumDontDeleteProperty.
		Smee.SmeeBuiltinFunctionProperty.
		Smee.SmeeString.
		Smee.SmeeNullObject.
		Smee.SmeeInfinity.
		Smee.SmeeNotANumber
	}</body>
</methods>


<methods>
<class-id>UI.ValueHolder</class-id> <category>accessing</category>

<body package="PV-Base Extensions" selector="valueWithArguments:">valueWithArguments: arguments

	| size |
	size := arguments size.
	size == 0 ifTrue: [^self value].
	size == 1 ifTrue: [^self value: arguments first].
	^self error: 'Too Many Arguments'</body>
</methods>


<methods>
<class-id>Core.Collection</class-id> <category>enumerating</category>

<body package="PV-Base Extensions" selector="do:onLast:">do: eachBlock onLast: lastBlock 
	
	| previous placebo |
	placebo := Object new.
	previous := placebo.
	self do: 
		[:each | 
		previous == placebo 
			ifFalse: [eachBlock value: previous].
		previous := each].
	previous == placebo 
		ifFalse: [lastBlock value: previous]</body>
</methods>


<class>
<name>SimpleSerializerStandIn</name>
<environment>PROVISO</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>wrappee readStrategy writeStrategy </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-Base Extensions</category>
<attributes>
<package>PV-Base Extensions</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.SimpleSerializerStandIn</class-id> <category>public</category>

<body package="PV-Base Extensions" selector="writeTo:">writeTo: aSimpleSerializer 
	
	aSimpleSerializer write: readStrategy.
	aSimpleSerializer writeClass: wrappee class.
	writeStrategy value.</body>

<body package="PV-Base Extensions" selector="readFrom:">readFrom: aSimpleSerializer 
	
	| class |
	readStrategy := aSimpleSerializer read.
	class := aSimpleSerializer readClass.
	wrappee := aSimpleSerializer instantiate: class.
	^aSimpleSerializer 
		perform: readStrategy
		with: wrappee</body>
</methods>

<methods>
<class-id>PROVISO.SimpleSerializerStandIn</class-id> <category>initialize-release</category>

<body package="PV-Base Extensions" selector="initializeOn:readUsing:writeUsing:">initializeOn: anObject readUsing: aSymbol writeUsing: aBlock 
	
	wrappee := anObject.
	readStrategy := aSymbol.
	writeStrategy := aBlock</body>
</methods>


<methods>
<class-id>PROVISO.SimpleSerializerStandIn class</class-id> <category>creation</category>

<body package="PV-Base Extensions" selector="on:readUsing:writeUsing:">on: anObject readUsing: aSymbol writeUsing: aBlock 
	
	^self basicNew
		initializeOn: anObject
			readUsing: aSymbol
			writeUsing: aBlock;
		yourself</body>

<body package="PV-Base Extensions" selector="write:on:read:using:">write: anObject on: aSimpleSerializer read: aSymbol using: aBlock 
	
	| instance |
	instance := 
		self 
			on: anObject
			readUsing: aSymbol
			writeUsing: aBlock.
	^aSimpleSerializer write: instance</body>
</methods>


<methods>
<class-id>Core.PositionableStream</class-id> <category>As yet unclassified</category>

<body package="PV-Base Extensions" selector="rewindAfter:">rewindAfter: aValuable 
	
	self position ifNotNil: 
		[:savePosition | 
		^[aValuable value] 
			ensure: [self position: savePosition]]</body>
</methods>


<methods>
<class-id>Core.Stream</class-id> <category>accessing</category>

<body package="PV-Base Extensions" selector="untilEndDo:">untilEndDo: aMonadic

	[self atEnd] whileFalse: [aMonadic value: self]</body>
</methods>


<class>
<name>PvUnixSystemSupport</name>
<environment>PROVISO</environment>
<super>PROVISO.PvSystemSupport</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvUnixSystemSupportDictionary.*
			</imports>
<category>PV-Support</category>
<attributes>
<includeFiles><item>sys/types.h</item> <item>sys/statvfs.h</item> <item>unistd.h</item> <item>sys/stat.h</item> <item>netdb.h</item> <item>sys/systeminfo.h</item></includeFiles>
<includeDirectories><item>/usr/include</item></includeDirectories>
<libraryFiles><item>libprovisodc.so</item> <item>libc.so</item> <item>libnsl.so</item></libraryFiles>
<libraryDirectories><item>[unix]/usr/lib</item> <item>[win]$(windir)\system32</item> <item>/home/cmeshare/masters/baseGuam/linux86</item></libraryDirectories>
<beVirtual>false</beVirtual>
<optimizationLevel>debug</optimizationLevel>
<package>PV-Base Extensions</package>
</attributes>
</class>

<class>
<name>PvLinuxSystemSupport</name>
<environment>PROVISO</environment>
<super>PROVISO.PvUnixSystemSupport</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvLinuxSystemSupportDictionary.*
			</imports>
<category>PV-Support</category>
<attributes>
<includeFiles><item>sys/types.h</item> <item>sys/statvfs.h</item> <item>unistd.h</item> <item>sys/stat.h</item></includeFiles>
<includeDirectories><item>/usr/include</item></includeDirectories>
<libraryFiles><item>libc.so</item> <item>libprovisodc.so</item></libraryFiles>
<libraryDirectories><item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/home/bbuxton/vw/Ginger/current</item> <item>[unix]/usr/lib</item> <item>[win]$(windir)\system32</item> <item>/home/cmeshare/masters/baseGinger/linux86</item></libraryDirectories>
<beVirtual>false</beVirtual>
<optimizationLevel>debug</optimizationLevel>
<package>PV-Base Extensions</package>
</attributes>
</class>


<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>instantiation</category>

<body package="PV-Support" selector="instantiateSmeeInfinity:">instantiateSmeeInfinity: aClass

	^nil</body>

<body package="PV-Support" selector="instantiateSmeeNotANumber:">instantiateSmeeNotANumber: aClass

	^Smee.SmeeNaN</body>
</methods>

<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>reading</category>

<body package="PV-Support" selector="readSmeeArray2:">readSmeeArray2: aSmeeArray 
	
	^self readSmeeObjectProperties: aSmeeArray</body>

<body package="PV-Support" selector="readSmeeObjectProperties:">readSmeeObjectProperties: aSmeeObject 
	
	| sizeOrProperties |
	sizeOrProperties := self read.
	sizeOrProperties isNumber 
		ifFalse: 
			[aSmeeObject smeeProperties: sizeOrProperties.
			^aSmeeObject].
	sizeOrProperties timesRepeat: 
		[| key value |
		key := self read.
		value := self read.
		aSmeeObject 
			smeeAt: key
			put: value].
	^aSmeeObject</body>

<body package="PV-Support" selector="readSmeeString:">readSmeeString: aSmeeString

	aSmeeString value: self read.
	^aSmeeString</body>

<body package="PV-Support" selector="readSmeeObject:">readSmeeObject: aSmeeObject 
	
	^self readSmeeObjectProperties: aSmeeObject</body>

<body package="PV-Support" selector="readSmeeObject2:">readSmeeObject2: aSmeeObject 
	
	self readSmeeObject: aSmeeObject.
	aSmeeObject smeePrototype: self read.
	^aSmeeObject</body>

<body package="PV-Support" selector="readSmeeNullObject:">readSmeeNullObject: aSmeeNull

	^Smee.SmeeNull</body>

<body package="PV-Support" selector="readSmeeNotANumber:">readSmeeNotANumber: aSmeeNotANumber

	^aSmeeNotANumber</body>

<body package="PV-Support" selector="readSmeeInfinity:">readSmeeInfinity: aSmeeInfinity 
	
	^self read 
		ifTrue: [Smee.SmeeInfinity positive]
		ifFalse: [Smee.SmeeInfinity negative]</body>

<body package="PV-Support" selector="readSmeeDate2:">readSmeeDate2: aSmeeDate 
	
	aSmeeDate value: self read.
	^self readSmeeObject2: aSmeeDate</body>
</methods>

<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>writing</category>

<body package="PV-Support" selector="writeSmeeInfinity:">writeSmeeInfinity: aSmeeInfinity

	self write: (aSmeeInfinity &gt; 0)</body>

<body package="PV-Support" selector="writeSmeeArray:">writeSmeeArray: aSmeeArray 
	
	^SimpleSerializerStandIn 
		write: aSmeeArray
		on: self
		read: #readSmeeArray2:
		using: 
			[self writeSmeeObjectProperties: aSmeeArray]</body>

<body package="PV-Support" selector="writeSmeeString:">writeSmeeString: aSmeeString

	self write: aSmeeString value</body>

<body package="PV-Support" selector="writeSmeeNullObject:">writeSmeeNullObject: aSmeeNull

	"do nothing"</body>

<body package="PV-Support" selector="writeSmeeObjectRaw:">writeSmeeObjectRaw: aSmeeObject 
	
	self writeSmeeObjectProperties: aSmeeObject.
	self write: aSmeeObject smeePrototype</body>

<body package="PV-Support" selector="writeSmeeObject:">writeSmeeObject: aSmeeObject 
	
	^SimpleSerializerStandIn 
		write: aSmeeObject
		on: self
		read: #readSmeeObject2:
		using: [self writeSmeeObjectRaw: aSmeeObject]</body>

<body package="PV-Support" selector="writeSmeeDate:">writeSmeeDate: aSmeeDate 
	
	^SimpleSerializerStandIn 
		write: aSmeeDate
		on: self
		read: #readSmeeDate2:
		using: 
			[self write: aSmeeDate value.
			self writeSmeeObjectRaw: aSmeeDate]</body>

<body package="PV-Support" selector="writeSmeeObjectProperties:">writeSmeeObjectProperties: aSmeeObject 
	
	| size |
	size := 0.
	aSmeeObject smeeSerializableKeysAndValuesDo: [:key :value | size := size + 1].
	self write: size.
	aSmeeObject smeeSerializableKeysAndValuesDo: 
		[:key :value | 
		self write: key.
		self write: value]</body>

<body package="PV-Support" selector="writeSmeeNotANumber:">writeSmeeNotANumber: aSmeeNotANumber

	^aSmeeNotANumber</body>
</methods>


<methods>
<class-id>PROVISO.PvTimestamp</class-id> <category>arithmetic</category>

<body package="PV-Support" selector="-">- aPvTimestamp 
	
	^Squeak.Duration milliSeconds: 
		self asUTCMilliseconds - aPvTimestamp asUTCMilliseconds</body>
</methods>

<methods>
<class-id>PROVISO.PvTimestamp</class-id> <category>accessing</category>

<body package="PV-Support" selector="yearEndSeconds">yearEndSeconds

	| secondsSince1901 |
	secondsSince1901 := 
		(Date 
			newDay: 1
			monthNumber: 1
			year: self year + 1) asSeconds.
	^secondsSince1901 - SecondsBetween1901and1970 - 1</body>

<body package="PV-Support" selector="yearStopSeconds">yearStopSeconds

	| secondsSince1901 |
	secondsSince1901 := 
		(Date 
			newDay: 1
			monthNumber: 1
			year: self year + 1) asSeconds.
	^secondsSince1901 - SecondsBetween1901and1970</body>

<body package="PV-Support" selector="yearStartSeconds">yearStartSeconds

	| secondsSince1901 |
	secondsSince1901 := 
		(Date 
			newDay: 1
			monthNumber: 1
			year: self year) asSeconds.
	^secondsSince1901 - SecondsBetween1901and1970.</body>
</methods>



</st-source>
